diff --git a/toolkit/components/sessionstore/SessionStoreParent.cpp b/toolkit/components/sessionstore/SessionStoreParent.cpp
--- a/toolkit/components/sessionstore/SessionStoreParent.cpp
+++ b/toolkit/components/sessionstore/SessionStoreParent.cpp
@@ -196,11 +196,11 @@
 
 mozilla::ipc::IPCResult SessionStoreParent::RecvIncrementalSessionStoreUpdate(
     const MaybeDiscarded<BrowsingContext>& aBrowsingContext,
     const Maybe<FormData>& aFormData, const Maybe<nsPoint>& aScrollPosition,
     uint32_t aEpoch) {
-  if (!aBrowsingContext.IsNull()) {
+  if (!aBrowsingContext.IsNullOrDiscarded()) {
     if (aFormData.isSome()) {
       mHasNewFormData = true;
     }
     if (aScrollPosition.isSome()) {
       mHasNewScrollPosition = true;
@@ -214,11 +214,11 @@
   return IPC_OK();
 }
 
 mozilla::ipc::IPCResult SessionStoreParent::RecvResetSessionStore(
     const MaybeDiscarded<BrowsingContext>& aBrowsingContext, uint32_t aEpoch) {
-  if (!aBrowsingContext.IsNull()) {
+  if (!aBrowsingContext.IsNullOrDiscarded()) {
     mSessionStore->RemoveSessionStore(
         aBrowsingContext.GetMaybeDiscarded()->Canonical());
   }
   return IPC_OK();
 }

